= How do I use an existing/remote Git repository? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

== Getting Started with Git on SecureCI™ == 

In order to use your repositories, you may need to run this command first: 
{{{
git config --global http.sslVerify false
}}}
since by default a cert from a trusted CA isn't being used for this site.

Then, clone the master repo of your choice with the following command:
{{{
git clone -v https://john.doe@secureci/git/playground
}}}

NOTE: This does NOT have a ".git" on the end of it.

This uses the your Trac / SecureCI™ username and password.

Your basic working model then becomes:
 * {{{... edit files locally ...}}} - work with whatever files you want
 * {{{git add [files]}}} - register new files with git. Add "." to recursively add everything.
 * {{{git commit -a}}} - commit all known local changes to your local cloned repository
 * {{{git push}}} - push your committed local repository changes up to the master repository
 * {{{git pull}}} - pull down master repository changes into your local repository
 
Git is very good about keeping track of distributed changes and merging them together. However, you will naturally get merge conflicts if you work on the same areas of code as someone else. Resolving conflicts this the subject of a much deeper introduction.

== Learning Git ==

There are a bunch of resources out there to learn. A few of our favorites are:
 * [https://try.github.io/levels/1/challenges/1 Learn Git] on github
 * [http://www.git-tower.com/learn/ Learn Version Control with Git] on git-tower
 * [http://git-scm.com/book/en/v2/Getting-Started-Git-Basics Git Basics] from git themselves

There are a variety of clients that make things easy to get started:
 * Tortoise GIT - now available as a port of Tortoise SVN. (Windows)
 * Eclipse eGit - plugin for eclipse that comes automatic with latest Juno release. Works nicely.

== Git Administration ==

The git repositories themselves are set up in /var/lib/git/git. They use the same username/password datastore at Trac and SVN and can be administered through the Trac UI.

[../UseGitBlit How do I manage my repositories with GitBlit?] has notes about how to administer these git repositories from a web interface.

You can also manage git from the command line.

{{{
cd /var/lib/git/git
sudo -u www-data git init --bare --shared ./playground.git
}}}
The "shared" is necessary to set permissions properly. You might consider editing the "*.git/description" file to describe your repository.

Add initial files so you can start working with it:
{{{
git clone /var/lib/git/git/playground.git
}}}

Add files, etc. in the playground directory.
{{{
git add .
git commit
git push origin master 
}}}
This creates the new "master" branch in empty repos.

Continue working...
{{{
(edit files)
git commit
git pull (merge, sync to master)
git push
}}}
 
<%= node['trac']['wiki']['footer'] %>